// simple shell access excecuted in a Java thread
// Zachary Seldess, 09/29/10

import java.io.*;
import com.cycling74.max.*;

public class shellAccess extends MaxObject {

	private Runtime run = Runtime.getRuntime();
	private Process pr;
	private boolean prRunning = false;

	private class MyThread extends Thread {
		private String[] parameter;
		private String line = null;

		public MyThread(String[] s) {
			parameter = s;
		}

		public void run() {				 
			try {
				pr = run.exec(parameter);
				//pr.waitFor();
				prRunning = true;

				BufferedReader buf = new BufferedReader(new InputStreamReader(pr.getInputStream()));
				line = buf.readLine();
				while (line != null) {
					output(0, line);
					line = buf.readLine();
				}
				prRunning = false;
			}
			catch (Exception e) {
				maxPost(e);
				prRunning = false;
			}		
		}

	}
		
	shellAccess() {
		declareIO(1,1);
		setInletAssist(0, "send incoming command to shell");
		setOutletAssist(0, "shell output results");
		createInfoOutlet(false);
	}
	
	public void anything(String msg, Atom[] args) {	

		if (msg.equals("destroy")) {
			if (prRunning) {
				pr.destroy();
				prRunning = false;
				post("process killed");
			}
			else {
				post("no process to kill!");
			}
		}
		else {
			String[] script = new String[args.length+1]; // set String[] to length of incoming message
			script[0] = msg;
			for (int i = 1; i < script.length; i++) {
				script[i] = args[i-1].toString(); // store each element in new String array
			}
			//outlet(0, script);
	
			runThread(script);
		}
	}

	private void output(int i, String s) {
		outlet(i, s);
	}

	private void maxPost(Exception e) {
		post("error: " + e);
	}

	private void runThread(String[] s) {
		MyThread p = new MyThread(s);
		p.start();
	}
}








































































